import 'package:flutter/material.dart';
import 'package:wakatime_api/apis/wakatime_api.dart';
import 'package:wakatime_api/models/project.dart';

void main() => runApp(const MyApp());

class MyApp extends StatelessWidget {
  const MyApp({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Wakatime api demo',
      theme: ThemeData(
        primarySwatch: Colors.blue,
      ),
      home: const MyHomePage(title: 'Flutter Demo Home Page'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  const MyHomePage({Key? key, required this.title}) : super(key: key);

  final String title;

  @override
  State<MyHomePage> createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  final _api = WakatimeApi('<YOUR_TOKEN>');

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
      ),
      body: Center(
        child: FutureBuilder<List<Project>>(
          future: _api.getProjects(),
          builder: (context, snap) => Column(
            mainAxisAlignment: MainAxisAlignment.center,
            children:
                snap.data?.map((project) => Text(project.name)).toList() ??
                    [
                      const Text('Loading...'),
                    ],
          ),
        ),
      ),
    );
  }
}
